| The Gaudi Framework v32r1 (f65d50dc)

Public Member Functions | Protected Member Functions | Static Private Member Functions | Private Attributes | List of all members
Gaudi::Details::PropertyBase Class Referenceabstract

PropertyBase base class allowing PropertyBase* collections to be "homogeneous". More...

`#include <GaudiKernel/Property.h>`

Inheritance diagram for Gaudi::Details::PropertyBase:
[legend]
Collaboration diagram for Gaudi::Details::PropertyBase:
[legend]

## Public Member Functions
const std::string | name () const
| property name More...
std::string | documentation () const
| property documentation More...
const std::type_info * | type_info () const
| property type-info More...
std::string | type () const
| property type More...
virtual bool | load (PropertyBase &dest) const =0
| export the property value to the destination More...
virtual bool | assign (const PropertyBase &source)=0
| import the property value form the source More...
virtual std::string | toString () const =0
| value -> string More...
virtual void | toStream (std::ostream &out) const =0
| value -> stream More...
virtual StatusCode | fromString (const std::string &value)=0
| string -> value More...
virtual PropertyBase & | declareReadHandler (std::function< void(PropertyBase &)> fun)=0
| set new callback for reading More...
virtual PropertyBase & | declareUpdateHandler (std::function< void(PropertyBase &)> fun)=0
| set new callback for update More...
virtual const std::function< void(PropertyBase &)> | readCallBack () const =0
| get a reference to the readCallBack More...
virtual const std::function< void(PropertyBase &)> | updateCallBack () const =0
| get a reference to the updateCallBack More...
virtual bool | useUpdateHandler ()=0
| manual trigger for callback for update More...
template<class HT >
PropertyBase & | declareReadHandler (void(HT::*MF)(PropertyBase &), HT *instance)
template<class HT >
PropertyBase & | declareUpdateHandler (void(HT::*MF)(PropertyBase &), HT *instance)
virtual | ~PropertyBase ()=default
| virtual destructor More...
void | setName (std::string value)
| set the new value for the property name More...
void | setDocumentation (std::string value)
| set the documentation string More...
virtual std::ostream & | fillStream (std::ostream &) const
| the printout of the property value More...
virtual PropertyBase * | clone () const =0
| clones the current property More...
void | setOwnerType (const std::type_info &ownerType)
| set the type of the owner class (used for documentation) More...
template<class OWNER >
void | setOwnerType ()
| set the type of the owner class (used for documentation) More...
const std::type_info * | ownerType () const
| get the type of the owner class (used for documentation) More...
std::string | ownerTypeName () const
| get the string for the type of the owner class (used for documentation) More...

## Protected Member Functions
| PropertyBase (const std::type_info &type, std::string name="", std::string doc="")
| constructor from the property name and the type More...
| PropertyBase (std::string name, const std::type_info &type)
| constructor from the property name and the type More...
| PropertyBase (const PropertyBase &)=default
| copy constructor More...
PropertyBase & | operator= (const PropertyBase &)=default
| assignment operator More...

## Static Private Member Functions
static std::string_view | to_view (std::string str)
| helper to map a string to a reliable std::string_view More...

## Private Attributes
std::string_view | m_name
| property name More...
std::string_view | m_documentation
| property doc string More...
const std::type_info * | m_typeinfo
| property type More...
const std::type_info * | m_ownerType = nullptr
| type of owner of the property (if defined) More...

## Detailed Description

PropertyBase base class allowing PropertyBase* collections to be "homogeneous".

Author
  Paul Maley
  CTDay
  Vanya BELYAEV ibely.nosp@m.aev@.nosp@m.physi.nosp@m.cs.s.nosp@m.yr.ed.nosp@m.u
  Marco Clemencic

Definition at line 32 of file Property.h.

## Constructor & Destructor Documentation

## ◆ ~PropertyBase()

virtual Gaudi::Details::PropertyBase::~PropertyBase | ( |  | ) |
| virtual default

virtual destructor

## ◆ PropertyBase() [1/3]

Gaudi::Details::PropertyBase::PropertyBase | ( | const std::type_info & | type,
|  | std::string | name = `""`,
|  | std::string | doc = `""`
| ) |  |
| inline protected

constructor from the property name and the type

Definition at line 111 of file Property.h.

112 : m_name( to_view( std::move( name ) ) )
113 , m_documentation( to_view( std::move( doc ) ) )
114 , m_typeinfo( &type ) {}
Gaudi::Details::PropertyBase::m_name
std::string_view m_name
property name
Definition: Property.h:127
Gaudi::Details::PropertyBase::name
const std::string name() const
property name
Definition: Property.h:36
Gaudi::Details::PropertyBase::to_view
static std::string_view to_view(std::string str)
helper to map a string to a reliable std::string_view
Definition: Property.cpp:42
Gaudi::Details::PropertyBase::m_typeinfo
const std::type_info * m_typeinfo
property type
Definition: Property.h:131
Gaudi::Details::PropertyBase::m_documentation
std::string_view m_documentation
property doc string
Definition: Property.h:129
std::move
T move(T... args)
Gaudi::Details::PropertyBase::type
std::string type() const
property type
Definition: Property.h:42

## ◆ PropertyBase() [2/3]

Gaudi::Details::PropertyBase::PropertyBase | ( | std::string | name,
|  | const std::type_info & | type
| ) |  |
| inline protected

constructor from the property name and the type

Definition at line 116 of file Property.h.

117 : m_name( to_view( std::move( name ) ) ), m_documentation( m_name ), m_typeinfo( &type ) {}
Gaudi::Details::PropertyBase::m_name
std::string_view m_name
property name
Definition: Property.h:127
Gaudi::Details::PropertyBase::name
const std::string name() const
property name
Definition: Property.h:36
Gaudi::Details::PropertyBase::to_view
static std::string_view to_view(std::string str)
helper to map a string to a reliable std::string_view
Definition: Property.cpp:42
Gaudi::Details::PropertyBase::m_typeinfo
const std::type_info * m_typeinfo
property type
Definition: Property.h:131
Gaudi::Details::PropertyBase::m_documentation
std::string_view m_documentation
property doc string
Definition: Property.h:129
std::move
T move(T... args)
Gaudi::Details::PropertyBase::type
std::string type() const
property type
Definition: Property.h:42

## ◆ PropertyBase() [3/3]

Gaudi::Details::PropertyBase::PropertyBase | ( | const PropertyBase & |  | ) |
| protected default

copy constructor

## Member Function Documentation

## ◆ assign()

virtual bool Gaudi::Details::PropertyBase::assign | ( | const PropertyBase & | source | ) |
| pure virtual

import the property value form the source

Implemented in Gaudi::Property< TYPE, VERIFIER, HANDLERS >, Gaudi::Property< long >, Gaudi::Property< std::vector< long > >, Gaudi::Property< std::string::size_type >, Gaudi::Property< map< std::string, std::string > >, Gaudi::Property< double >, Gaudi::Property< std::map >, Gaudi::Property< unsigned long long >, Gaudi::Property< std::vector< unsigned int > >, Gaudi::Property< std::string >, Gaudi::Property< float >, Gaudi::Property< std::unordered_set >, Gaudi::Property< std::vector< std::string > >, Gaudi::Property< int >, Gaudi::Property< unsigned int >, Gaudi::Property< CLID >, Gaudi::Property< size_t >, Gaudi::Property< HistoID::NumericID >, Gaudi::Property< bool >, Gaudi::Property< TupleID::NumericID >, Gaudi::Property< std::map< std::string, std::string > >, and Gaudi::Property< vector< std::string > >.

## ◆ clone()

virtual PropertyBase* Gaudi::Details::PropertyBase::clone | ( |  | ) | const
| pure virtual

clones the current property

Implemented in GaudiHandleArrayProperty, GaudiHandleProperty, Gaudi::Property< TYPE, VERIFIER, HANDLERS >, Gaudi::Property< long >, Gaudi::Property< std::vector< long > >, Gaudi::Property< std::string::size_type >, Gaudi::Property< map< std::string, std::string > >, Gaudi::Property< double >, Gaudi::Property< std::map >, Gaudi::Property< unsigned long long >, Gaudi::Property< std::vector< unsigned int > >, Gaudi::Property< std::string >, Gaudi::Property< float >, Gaudi::Property< std::unordered_set >, Gaudi::Property< std::vector< std::string > >, Gaudi::Property< int >, Gaudi::Property< unsigned int >, Gaudi::Property< CLID >, Gaudi::Property< size_t >, Gaudi::Property< HistoID::NumericID >, Gaudi::Property< bool >, Gaudi::Property< TupleID::NumericID >, Gaudi::Property< std::map< std::string, std::string > >, Gaudi::Property< vector< std::string > >, Gaudi::Property< TYPE[N], VERIFIER, HANDLERS >, and DataObjectHandleProperty.

## ◆ declareReadHandler() [1/2]

virtual PropertyBase& Gaudi::Details::PropertyBase::declareReadHandler | ( | std::function< void(PropertyBase &)> | fun | ) |
| pure virtual

set new callback for reading

Implemented in Gaudi::Property< TYPE, VERIFIER, HANDLERS >, Gaudi::Property< long >, Gaudi::Property< std::vector< long > >, Gaudi::Property< std::string::size_type >, Gaudi::Property< map< std::string, std::string > >, Gaudi::Property< double >, Gaudi::Property< std::map >, Gaudi::Property< unsigned long long >, Gaudi::Property< std::vector< unsigned int > >, Gaudi::Property< std::string >, Gaudi::Property< float >, Gaudi::Property< std::unordered_set >, Gaudi::Property< std::vector< std::string > >, Gaudi::Property< int >, Gaudi::Property< unsigned int >, Gaudi::Property< CLID >, Gaudi::Property< size_t >, Gaudi::Property< HistoID::NumericID >, Gaudi::Property< bool >, Gaudi::Property< TupleID::NumericID >, Gaudi::Property< std::map< std::string, std::string > >, and Gaudi::Property< vector< std::string > >.

## ◆ declareReadHandler() [2/2]

template<class HT >

PropertyBase& Gaudi::Details::PropertyBase::declareReadHandler | ( | void(HT::*)(PropertyBase &) | MF,
|  | HT * | instance
| ) |  |
| inline

Definition at line 71 of file Property.h.

71 {
72 return declareReadHandler( [=]( PropertyBase& p ) { ( instance->*MF )( p ); } );
73 }
Gaudi::Details::PropertyBase::PropertyBase
PropertyBase(const std::type_info &type, std::string name="", std::string doc="")
constructor from the property name and the type
Definition: Property.h:111
Gaudi::Details::PropertyBase::declareReadHandler
virtual PropertyBase & declareReadHandler(std::function< void(PropertyBase &)> fun)=0
set new callback for reading

## ◆ declareUpdateHandler() [1/2]

virtual PropertyBase& Gaudi::Details::PropertyBase::declareUpdateHandler | ( | std::function< void(PropertyBase &)> | fun | ) |
| pure virtual

set new callback for update

Implemented in Gaudi::Property< TYPE, VERIFIER, HANDLERS >, Gaudi::Property< long >, Gaudi::Property< std::vector< long > >, Gaudi::Property< std::string::size_type >, Gaudi::Property< map< std::string, std::string > >, Gaudi::Property< double >, Gaudi::Property< std::map >, Gaudi::Property< unsigned long long >, Gaudi::Property< std::vector< unsigned int > >, Gaudi::Property< std::string >, Gaudi::Property< float >, Gaudi::Property< std::unordered_set >, Gaudi::Property< std::vector< std::string > >, Gaudi::Property< int >, Gaudi::Property< unsigned int >, Gaudi::Property< CLID >, Gaudi::Property< size_t >, Gaudi::Property< HistoID::NumericID >, Gaudi::Property< bool >, Gaudi::Property< TupleID::NumericID >, Gaudi::Property< std::map< std::string, std::string > >, and Gaudi::Property< vector< std::string > >.

## ◆ declareUpdateHandler() [2/2]

template<class HT >

PropertyBase& Gaudi::Details::PropertyBase::declareUpdateHandler | ( | void(HT::*)(PropertyBase &) | MF,
|  | HT * | instance
| ) |  |
| inline

Definition at line 76 of file Property.h.

76 {
77 return declareUpdateHandler( [=]( PropertyBase& p ) { ( instance->*MF )( p ); } );
78 }
Gaudi::Details::PropertyBase::declareUpdateHandler
virtual PropertyBase & declareUpdateHandler(std::function< void(PropertyBase &)> fun)=0
set new callback for update
Gaudi::Details::PropertyBase::PropertyBase
PropertyBase(const std::type_info &type, std::string name="", std::string doc="")
constructor from the property name and the type
Definition: Property.h:111

## ◆ documentation()

std::string Gaudi::Details::PropertyBase::documentation | ( |  | ) | const
| inline

property documentation

Definition at line 38 of file Property.h.

38 { return std::string{m_documentation}; }
std::string
STL class.
Gaudi::Details::PropertyBase::m_documentation
std::string_view m_documentation
property doc string
Definition: Property.h:129

## ◆ fillStream()

std::ostream & PropertyBase::fillStream | ( | std::ostream & | stream | ) | const
| virtual

the printout of the property value

Definition at line 49 of file Property.cpp.

49 {
50 return stream << " '" << name() << "':" << toString();
51 }
Gaudi::Details::PropertyBase::name
const std::string name() const
property name
Definition: Property.h:36
Gaudi::Details::PropertyBase::toString
virtual std::string toString() const =0
value -> string

## ◆ fromString()

virtual StatusCode Gaudi::Details::PropertyBase::fromString | ( | const std::string & | value | ) |
| pure virtual

string -> value

Implemented in GaudiHandleArrayProperty, GaudiHandleProperty, Gaudi::Property< TYPE, VERIFIER, HANDLERS >, Gaudi::Property< long >, Gaudi::Property< std::vector< long > >, Gaudi::Property< std::string::size_type >, Gaudi::Property< map< std::string, std::string > >, Gaudi::Property< double >, Gaudi::Property< std::map >, Gaudi::Property< unsigned long long >, Gaudi::Property< std::vector< unsigned int > >, Gaudi::Property< std::string >, Gaudi::Property< float >, Gaudi::Property< std::unordered_set >, Gaudi::Property< std::vector< std::string > >, Gaudi::Property< int >, Gaudi::Property< unsigned int >, Gaudi::Property< CLID >, Gaudi::Property< size_t >, Gaudi::Property< HistoID::NumericID >, Gaudi::Property< bool >, Gaudi::Property< TupleID::NumericID >, Gaudi::Property< std::map< std::string, std::string > >, Gaudi::Property< vector< std::string > >, Gaudi::Property< TYPE[N], VERIFIER, HANDLERS >, and DataObjectHandleProperty.

## ◆ load()

virtual bool Gaudi::Details::PropertyBase::load | ( | PropertyBase & | dest | ) | const
| pure virtual

export the property value to the destination

Implemented in Gaudi::Property< TYPE, VERIFIER, HANDLERS >, Gaudi::Property< long >, Gaudi::Property< std::vector< long > >, Gaudi::Property< std::string::size_type >, Gaudi::Property< map< std::string, std::string > >, Gaudi::Property< double >, Gaudi::Property< std::map >, Gaudi::Property< unsigned long long >, Gaudi::Property< std::vector< unsigned int > >, Gaudi::Property< std::string >, Gaudi::Property< float >, Gaudi::Property< std::unordered_set >, Gaudi::Property< std::vector< std::string > >, Gaudi::Property< int >, Gaudi::Property< unsigned int >, Gaudi::Property< CLID >, Gaudi::Property< size_t >, Gaudi::Property< HistoID::NumericID >, Gaudi::Property< bool >, Gaudi::Property< TupleID::NumericID >, Gaudi::Property< std::map< std::string, std::string > >, and Gaudi::Property< vector< std::string > >.

## ◆ name()

const std::string Gaudi::Details::PropertyBase::name | ( |  | ) | const
| inline

property name

Definition at line 36 of file Property.h.

36 { return std::string{m_name}; }
Gaudi::Details::PropertyBase::m_name
std::string_view m_name
property name
Definition: Property.h:127
std::string
STL class.

## ◆ operator=()

PropertyBase& Gaudi::Details::PropertyBase::operator= | ( | const PropertyBase & |  | ) |
| protected default

assignment operator

## ◆ ownerType()

const std::type_info* Gaudi::Details::PropertyBase::ownerType | ( |  | ) | const
| inline

get the type of the owner class (used for documentation)

Definition at line 102 of file Property.h.

102 { return m_ownerType; }
Gaudi::Details::PropertyBase::m_ownerType
const std::type_info * m_ownerType
type of owner of the property (if defined)
Definition: Property.h:133

## ◆ ownerTypeName()

std::string Gaudi::Details::PropertyBase::ownerTypeName | ( |  | ) | const
| inline

get the string for the type of the owner class (used for documentation)

Definition at line 105 of file Property.h.

105 {
106 return m_ownerType ? System::typeinfoName( *m_ownerType ) : std::string( "unknown owner type" );
107 }
System::typeinfoName
GAUDI_API const std::string typeinfoName(const std::type_info &)
Get platform independent information about the class type.
Definition: System.cpp:298
std
STL namespace.
Gaudi::Details::PropertyBase::m_ownerType
const std::type_info * m_ownerType
type of owner of the property (if defined)
Definition: Property.h:133

## ◆ readCallBack()

virtual const std::function<void( PropertyBase& )> Gaudi::Details::PropertyBase::readCallBack | ( |  | ) | const
| pure virtual

get a reference to the readCallBack

Implemented in PropertyWithHandlers< Handler >, PropertyWithHandlers<>, Gaudi::Property< TYPE, VERIFIER, HANDLERS >, Gaudi::Property< long >, Gaudi::Property< std::vector< long > >, Gaudi::Property< std::string::size_type >, Gaudi::Property< map< std::string, std::string > >, Gaudi::Property< double >, Gaudi::Property< std::map >, Gaudi::Property< unsigned long long >, Gaudi::Property< std::vector< unsigned int > >, Gaudi::Property< std::string >, Gaudi::Property< float >, Gaudi::Property< std::unordered_set >, Gaudi::Property< std::vector< std::string > >, Gaudi::Property< int >, Gaudi::Property< unsigned int >, Gaudi::Property< CLID >, Gaudi::Property< size_t >, Gaudi::Property< HistoID::NumericID >, Gaudi::Property< bool >, Gaudi::Property< TupleID::NumericID >, Gaudi::Property< std::map< std::string, std::string > >, Gaudi::Property< vector< std::string > >, and Gaudi::Property< TYPE[N], VERIFIER, HANDLERS >.

## ◆ setDocumentation()

void Gaudi::Details::PropertyBase::setDocumentation | ( | std::string | value | ) |
| inline

set the documentation string

Definition at line 86 of file Property.h.

86 { m_documentation = to_view( std::move( value ) ); }
Gaudi::Details::PropertyBase::to_view
static std::string_view to_view(std::string str)
helper to map a string to a reliable std::string_view
Definition: Property.cpp:42
Gaudi::Details::PropertyBase::m_documentation
std::string_view m_documentation
property doc string
Definition: Property.h:129
std::move
T move(T... args)

## ◆ setName()

void Gaudi::Details::PropertyBase::setName | ( | std::string | value | ) |
| inline

set the new value for the property name

Definition at line 84 of file Property.h.

84 { m_name = to_view( std::move( value ) ); }
Gaudi::Details::PropertyBase::m_name
std::string_view m_name
property name
Definition: Property.h:127
Gaudi::Details::PropertyBase::to_view
static std::string_view to_view(std::string str)
helper to map a string to a reliable std::string_view
Definition: Property.cpp:42
std::move
T move(T... args)

## ◆ setOwnerType() [1/2]

void Gaudi::Details::PropertyBase::setOwnerType | ( | const std::type_info & | ownerType | ) |
| inline

set the type of the owner class (used for documentation)

Definition at line 93 of file Property.h.

93 { m_ownerType = &ownerType; }
Gaudi::Details::PropertyBase::m_ownerType
const std::type_info * m_ownerType
type of owner of the property (if defined)
Definition: Property.h:133
Gaudi::Details::PropertyBase::ownerType
const std::type_info * ownerType() const
get the type of the owner class (used for documentation)
Definition: Property.h:102

## ◆ setOwnerType() [2/2]

template<class OWNER >

void Gaudi::Details::PropertyBase::setOwnerType | ( |  | ) |
| inline

set the type of the owner class (used for documentation)

Definition at line 97 of file Property.h.

97 {
98 setOwnerType( typeid( OWNER ) );
99 }
Gaudi::Details::PropertyBase::setOwnerType
void setOwnerType()
set the type of the owner class (used for documentation)
Definition: Property.h:97

## ◆ to_view()

std::string_view PropertyBase::to_view | ( | std::string | str | ) |
| static private

helper to map a string to a reliable std::string_view

Definition at line 42 of file Property.cpp.

42 {
43 return **( all_strings.insert( std::make_unique<std::string>( std::move( str ) ) ).first );
44 }
std::move
T move(T... args)

## ◆ toStream()

virtual void Gaudi::Details::PropertyBase::toStream | ( | std::ostream & | out | ) | const
| pure virtual

value -> stream

Implemented in GaudiHandleArrayProperty, GaudiHandleProperty, Gaudi::Property< TYPE, VERIFIER, HANDLERS >, Gaudi::Property< long >, Gaudi::Property< std::vector< long > >, Gaudi::Property< std::string::size_type >, Gaudi::Property< map< std::string, std::string > >, Gaudi::Property< double >, Gaudi::Property< std::map >, Gaudi::Property< unsigned long long >, Gaudi::Property< std::vector< unsigned int > >, Gaudi::Property< std::string >, Gaudi::Property< float >, Gaudi::Property< std::unordered_set >, Gaudi::Property< std::vector< std::string > >, Gaudi::Property< int >, Gaudi::Property< unsigned int >, Gaudi::Property< CLID >, Gaudi::Property< size_t >, Gaudi::Property< HistoID::NumericID >, Gaudi::Property< bool >, Gaudi::Property< TupleID::NumericID >, Gaudi::Property< std::map< std::string, std::string > >, Gaudi::Property< vector< std::string > >, Gaudi::Property< TYPE[N], VERIFIER, HANDLERS >, and DataObjectHandleProperty.

## ◆ toString()

virtual std::string Gaudi::Details::PropertyBase::toString | ( |  | ) | const
| pure virtual

value -> string

Implemented in GaudiHandleArrayProperty, GaudiHandleProperty, Gaudi::Property< TYPE, VERIFIER, HANDLERS >, Gaudi::Property< long >, Gaudi::Property< std::vector< long > >, Gaudi::Property< std::string::size_type >, Gaudi::Property< map< std::string, std::string > >, Gaudi::Property< double >, Gaudi::Property< std::map >, Gaudi::Property< unsigned long long >, Gaudi::Property< std::vector< unsigned int > >, Gaudi::Property< std::string >, Gaudi::Property< float >, Gaudi::Property< std::unordered_set >, Gaudi::Property< std::vector< std::string > >, Gaudi::Property< int >, Gaudi::Property< unsigned int >, Gaudi::Property< CLID >, Gaudi::Property< size_t >, Gaudi::Property< HistoID::NumericID >, Gaudi::Property< bool >, Gaudi::Property< TupleID::NumericID >, Gaudi::Property< std::map< std::string, std::string > >, Gaudi::Property< vector< std::string > >, Gaudi::Property< TYPE[N], VERIFIER, HANDLERS >, and DataObjectHandleProperty.

## ◆ type()

std::string Gaudi::Details::PropertyBase::type | ( |  | ) | const
| inline

property type

Definition at line 42 of file Property.h.

42 { return m_typeinfo->name(); }
Gaudi::Details::PropertyBase::m_typeinfo
const std::type_info * m_typeinfo
property type
Definition: Property.h:131
std::type_info::name
T name(T... args)

## ◆ type_info()

const std::type_info* Gaudi::Details::PropertyBase::type_info | ( |  | ) | const
| inline

property type-info

Definition at line 40 of file Property.h.

40 { return m_typeinfo; }
Gaudi::Details::PropertyBase::m_typeinfo
const std::type_info * m_typeinfo
property type
Definition: Property.h:131

## ◆ updateCallBack()

virtual const std::function<void( PropertyBase& )> Gaudi::Details::PropertyBase::updateCallBack | ( |  | ) | const
| pure virtual

get a reference to the updateCallBack

Implemented in PropertyWithHandlers< Handler >, PropertyWithHandlers<>, Gaudi::Property< TYPE, VERIFIER, HANDLERS >, Gaudi::Property< long >, Gaudi::Property< std::vector< long > >, Gaudi::Property< std::string::size_type >, Gaudi::Property< map< std::string, std::string > >, Gaudi::Property< double >, Gaudi::Property< std::map >, Gaudi::Property< unsigned long long >, Gaudi::Property< std::vector< unsigned int > >, Gaudi::Property< std::string >, Gaudi::Property< float >, Gaudi::Property< std::unordered_set >, Gaudi::Property< std::vector< std::string > >, Gaudi::Property< int >, Gaudi::Property< unsigned int >, Gaudi::Property< CLID >, Gaudi::Property< size_t >, Gaudi::Property< HistoID::NumericID >, Gaudi::Property< bool >, Gaudi::Property< TupleID::NumericID >, Gaudi::Property< std::map< std::string, std::string > >, Gaudi::Property< vector< std::string > >, and Gaudi::Property< TYPE[N], VERIFIER, HANDLERS >.

## ◆ useUpdateHandler()

virtual bool Gaudi::Details::PropertyBase::useUpdateHandler | ( |  | ) |
| pure virtual

manual trigger for callback for update

Implemented in PropertyWithHandlers< Handler >, PropertyWithHandlers<>, Gaudi::Property< TYPE, VERIFIER, HANDLERS >, Gaudi::Property< long >, Gaudi::Property< std::vector< long > >, Gaudi::Property< std::string::size_type >, Gaudi::Property< map< std::string, std::string > >, Gaudi::Property< double >, Gaudi::Property< std::map >, Gaudi::Property< unsigned long long >, Gaudi::Property< std::vector< unsigned int > >, Gaudi::Property< std::string >, Gaudi::Property< float >, Gaudi::Property< std::unordered_set >, Gaudi::Property< std::vector< std::string > >, Gaudi::Property< int >, Gaudi::Property< unsigned int >, Gaudi::Property< CLID >, Gaudi::Property< size_t >, Gaudi::Property< HistoID::NumericID >, Gaudi::Property< bool >, Gaudi::Property< TupleID::NumericID >, Gaudi::Property< std::map< std::string, std::string > >, Gaudi::Property< vector< std::string > >, and Gaudi::Property< TYPE[N], VERIFIER, HANDLERS >.

## Member Data Documentation

## ◆ m_documentation

std::string_view Gaudi::Details::PropertyBase::m_documentation
| private

property doc string

Definition at line 129 of file Property.h.

## ◆ m_name

std::string_view Gaudi::Details::PropertyBase::m_name
| private

property name

Definition at line 127 of file Property.h.

## ◆ m_ownerType

const std::type_info* Gaudi::Details::PropertyBase::m_ownerType = nullptr
| private

type of owner of the property (if defined)

Definition at line 133 of file Property.h.

## ◆ m_typeinfo

const std::type_info* Gaudi::Details::PropertyBase::m_typeinfo
| private

property type

Definition at line 131 of file Property.h.

The documentation for this class was generated from the following files:

- GaudiKernel/GaudiKernel/Property.h
- GaudiKernel/src/Lib/Property.cpp